extern void delay (unsigned int us);

#ifndef cbi
#define cbi(sfr, bit)     (_SFR_BYTE(sfr) &= ~_BV(bit)) 
#endif
#ifndef sbi
#define sbi(sfr, bit)     (_SFR_BYTE(sfr) |= _BV(bit))  
#endif

typedef union conver_ {
	unsigned long dw;
	unsigned int w[2];
	unsigned char b[4];
} CONVERTDW;

typedef union conver2_ {
	unsigned int w;
	unsigned char b[2];
} CONVERTW;


volatile struct {
   unsigned first_start_:1; // 1 Bit fr bStatus_1
   unsigned master_start_:1; // 1 Bit fr bStatus_2
   unsigned i_am_master:1; // Und hier noch mal ein Bit
   unsigned RX_err:1; // for CRC-ERROR at RX
   unsigned ascii_to_int:1;//if active, convert int to ascii
 //  unsigned ecg_data:1;//if activated, send 09 for ECG & all data as ascii
   unsigned send_sinus:1;//send sinus on/off
   unsigned user_interface:1;//if user is writing anything on terminal
  
//   unsigned lernfahrt_done:1;//if one, then can start open_close function, but not before
}flag_1;

volatile struct {

   unsigned config_:1;//in config menue or not
   unsigned temp_was_read:1;//temperature was read or not
 //  unsigned fragmentation_of_frame:1;
   unsigned temp_msr:1;//flag for temp measurement
//   unsigned lernfahrt_done:1;//if one, then can start open_close function, but not before
}flag_2;
