
//#include <stdio.h>		//meine aenderung dennis
#include <string.h>		//meine aenderung dennis

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include <math.h>

#include <avr/sleep.h>
#include "portbits.h"
#include "global.h"
#include "uart.h"
#include "rf12.h"
#include "leds.h"
#include "timer.h"
#include "adc.h"
//#include "config.h"
#include "sht11.h"
//#include "atmega_bmp085_lib.h"
//#include "twi_lib.h"
#include "bmp.h"



#define F_CPU 3686400UL
#include <util/delay.h>
//#define F_CPU 3686400UL//4000000UL



//#define DEBUG						// anstelle der empfangenen Daten fr jede Aktion den Status ausgeben

#define USE_SOFTCONFIG				// Konfiguration ber ein einfaches Men (auskommentieren wenn nicht verwendet), nicht zusammen mit DIPSWITCH verwenden
//#define USE_DIPSWITCH				// DIP Schalter/Jumper an PortC 0-4 (auskommentieren wenn nicht verwendet), nicht zusammen mit SOFTCONFIG verwenden
#define CHANNEL			2			// Sende/Empfangskanal (0-3) (nur gltig wenn kein DIP Schalter verwendet wird)
#define RF_BAUDRATE		20000		// Baudrate des RFM12 (nur gltig wenn kein DIP Schalter verwendet wird)
#define UART_BAUDRATE	19200		// Baudrate des UARTs (nur gltig wenn kein DIP Schalter verwendet wird)
#define THRESHOLD		6			//meine aenderung dennis
#define _BANDWIDTH_     4			//meine aenderung dennis
#define OUTPUT_POWER	0
//#define FIRST_START		1

#define CONFIG_BAUD		19200		// Baudrate des UARTs (nur gltig im Config Mode)
#define MAX_BUF			255		// Paket Gre in Bytes (maximal 250, siehe auch rf12.c)
#define TX_TIMEOUT		150			// Maximale Wartezeit auf Daten in ms (max 500)
#define ANSWER_TIMEOUT	10			// Maximale Wartezeit auf die Besttigung der Daten in ms (max 500)
#define RETRY			15			// Maximale Anzahl an Sendeversuchen
#define MAX_ID_X		12
#define MAX_ID_Y		1

#define TRUE			1
#define FALSE			0

#define CONFIG			PINB_1		// Pin f�r Config Jumper (DDR beachten)	???????????????????????????????????
#define DEBOUNCE		200L			// debounce clock (256Hz = 4msec) //SENSOR TEMP


volatile unsigned char delaycnt;


//unsigned char rxbuf[MAX_BUF+1];		// Puffer fr empfangene Daten
//unsigned char txbuf[MAX_BUF+1];		// Puffer fr zu sendende Daten
signed char rxbuf[MAX_BUF+1];		// Puffer fr empfangene Daten
signed char txbuf[MAX_BUF+1];		// Puffer fr zu sendende Daten
unsigned char flags, tx_id, tx_status, retrans_cnt, ID_cnt=0;
unsigned char tx_cnt;
unsigned char ID_numbers[MAX_ID_X][MAX_ID_Y];	//array to save ID numbers
char ID_to_delete;
char input_check;
char source_ID[13];	//own ID of the node
char destination_ID[13];
unsigned char command_ =0; 
unsigned char broadcast_ID=111;			//4*111=111111111111
unsigned char msg_to_ID=0;
unsigned char send_cmd=0;
unsigned char master_saved=0;
unsigned long settings_variable=0;
unsigned int  timer0_cnt=0;	//veerification, if mastetr ID was saved
unsigned char data_number=0;
unsigned char cnt_2=0;
//unsigned char aaa=1;
signed char temperature_1=0;//another temp variable necessary, because temp_x is changing steadely
signed char temperature_2=0;
unsigned int fragmentation_size=0;//no fragmentation, 100 bytes, 50 bytes
int timer_to_send_sin=0;
unsigned int packet_cnt=0;

//****************TEMP SENSOR
unsigned char prescaler;
unsigned char volatile timevalue;			// Zhler fr Zeitwert

unsigned char send;

char command[11];      // String mit maximal 11 zeichen
char s[12];
char pres_buf[40];

//********* test string
signed char hallo_string[101];


volatile short sec = 0;
volatile char r[80],u[50];
volatile short ADC_erg,y1,y2,z1,z2,t=0,ready,sleep;
short sht_switch = 0;


#ifdef USE_SOFTCONFIG

	uint16_t my_ID_2_1;
	uint16_t my_ID_2_2;
	uint16_t my_ID_2_3;
	uint16_t uart_baud;
	uint16_t  rf_baud;
	uint8_t channel;
	uint8_t bandwidth_1;
	uint8_t environment_1;
	uint8_t threshold_1;
	uint8_t output_power_1;


	uint8_t i_am_master_eeprom EEMEM;
	uint8_t data_in_ID_eeprom EEMEM;
	uint16_t my_ID_2_1_eeprom EEMEM;
	uint16_t my_ID_2_2_eeprom EEMEM;
	uint16_t my_ID_2_3_eeprom EEMEM;
	uint8_t data_in_eeprom EEMEM;
	uint8_t threshold_1_eeprom EEMEM;
	uint8_t output_power_1_eeprom EEMEM;
	uint8_t environment_1_eeprom EEMEM;
	uint8_t bandwidth_1_eeprom EEMEM;
	uint16_t uart_baud_eeprom EEMEM;
	uint16_t rf_baud_eeprom EEMEM;
	uint8_t channel_eeprom EEMEM;
		
#endif

#define WAITFORACK		1

void rx_packet(void);
void tx_packet(unsigned char retrans);
void load_settings(void);
void save_settings(void);
void configmode(void);
unsigned long read_number(unsigned long min, unsigned long max, unsigned long remote_change);
void show_number(unsigned long val);
void save_ID_function(unsigned char save_ID_array[]);
void ID_delete_function(unsigned int number);	//function to delete the ID
//void message_array(unsigned char msg_array[]);	//function to display broadcast data on the screen
void message_array(void);
unsigned long ADC_Init(void);
unsigned long ADC_Read(void);
void random_number(void);
void segmentation(unsigned char string_for_segmentation[]);		//function for segmentation
void show_ID_function(void);		//function to display the IDs
void command_function(void);	//depending on cmd, different frametypes
void first_registration(void);	//fnc. slave registration, sending of broadcast msg. till master is found
void temp_measurement(void);	//fnc. to measure temperature
void send_command_(void);	//fnc. to assign special command
void header_fnc (void);	//fnc. contains all header data like, dest.ID, source ID...
void int_to_ascii(void);//testfunction
void send_sin (void);
void fill_the_frame(void);



int main(void)
{



#ifdef USE_SOFTCONFIG
	PORTD=255;
	DDRD=230;
	DDRA|=(1<<6);

#else
	PORTD=15;
	PORTC=255;
	DDRD=242;
	DDRB=0;			// config-Taster Pin 1 = 0 = Eingang
#endif



//***************** TIMER 0 konfigurieren	/2ms interrupt
 	 TCCR0 = (1<<WGM01)|(1<<CS01)|(1<<CS00); // CTC Modus
//	 TCCR0 |= (1<<CS01)|(1<<CS00); // Prescaler 64
//	 TCNT0=0;
 	 OCR0 = 115;
 	 TIMSK |= (1<<OCIE0);

	sei();
	rf12_init();									// ein paar Register setzen (z.B. CLK auf 10MHz)

 
#ifdef USE_SOFTCONFIG
	load_settings();
	//if (!CONFIG)
	if (CONFIG)
		configmode();
    uart_init(UART_BAUD_SELECT(uart_baud, F_CPU));
	rf12_config(rf_baud, channel, output_power_1, environment_1,threshold_1,bandwidth_1);	// Baudrate, Kanal (0-3), Leistung (0=max, 7=min), Umgebungsbedingungen (QUIET, NORMAL, NOISY)
	//TCCR0 = (0<<CS01);
	#else
    uart_init(UART_BAUD_SELECT(UART_BAUDRATE, F_CPU));
	rf12_config(RF_BAUDRATE, CHANNEL, OUTPUT_POWER, QUIET,THRESHOLD,_BANDWIDTH_);	// Baudrate, Kanal (0-3), Leistung (0=max, 7=min), Umgebungsbedingungen (QUIET, NORMAL, NOISY)
#endif

_delay_ms(70);

uart_puts("RST\r\n");

//	rf12_rxmode();

	PORTA&=~(1<<6);


	init_timer2();
	ADC_init();
	sht11_init();
	_delay_ms(50);
	

	DDRB  |= 7;
	PORTB |= 7;		

	
	for (;;)
	{

		if(sleep == 1)
		{
			//set_sleep_mode(SLEEP_MODE_PWR_SAVE);
   			//sleep_mode();                   // in den Schlafmodus wechseln
 			sleep = 0;
		}

		if(ready == 0)
		{
			if(sht_switch == 0)
			{
			sht11_start_measure();
			sht_switch = 1;
			}
			else
			{
			sht11_measure_finish();
			sht_switch = 0;
			}

			ADC_erg = ADC_read();

			y1 = sht11_get_tmp()/100;
			y2 = sht11_get_tmp()%100;
			z1 = sht11_get_hum();				// /100; 
			z2 = sht11_get_hum()%100;

			extern long int res_pressure;
			
			BMP();
			
			extern long int temp_bmp;
		
			sprintf(&r,"%4d;%4d;%4d;%ld;%ld\r\n"
			, t, ADC_erg, z1, temp_bmp, res_pressure);				
			
			//sprintf(&r,"Zeit:%4dmin;  Rain:%4d;  RH:%2d.%2d;  Temp:%ld;  Luftdruck NN:%ld\r\n"
			//, t, ADC_erg, z1, z2, temp_bmp/10, res_pressure);
			
			tx_via_radio(r);
			
			uart_puts("sendet");
			

			t++;	
			sec = 0;
			ready = 1;	
		}





		if (rf12_data() && flag_1.user_interface==0)							// Daten im RF12 RX Puffer ? and no data in txbuf
		{	
			rx_packet();
			flag_1.RX_err = 0;
		}

			if ((uart_data()) && flag_2.config_==0 )	//if data in UART buffer or first time connection establishment	
			{		
				
				if((uart_data()) || flag_1.user_interface==1 )
				{
					flag_1.user_interface=1;	//during this period no receive and transmit of data possible
							
				
				//**************************
				input_check=uart_getchar();				
				
				if(input_check==8)		//if backspace was pressed
				{
					txbuf[tx_cnt]=0;
					tx_cnt--;
				}
				else if(input_check==13)
				{
			//	uart_puts("enter\r\n");

			//	uart_puts(txbuf);

			
					flag_1.user_interface=0;

				//		if(flag_1.ecg_data)//if enter and int to ascii cool int_to_ascii function and copy data to txbuf
				//		int_to_ascii();
				}
				else
				{
				
						txbuf[tx_cnt++]=input_check;			
						uart_putc(input_check);	
				
				}


			
		}
			if (((tx_cnt>=MAX_BUF)||(input_check==13)) && flag_1.user_interface==0)	
			{	

			uart_puts_P("sent: ");
			uart_puts(txbuf);
				uart_puts("\r\n");
				

				input_check=NULL;					//delete the last entry "enter"
			//	send_cmd=0;
				tx_status=0;						// zu sendender Status
				tx_packet(0);						// erstmaliger Transfer
#ifdef DEBUG
				uart_putc('t');
#endif
	//	uart_puts_P(" 35 ");
				
				memset(txbuf,0,MAX_BUF*sizeof(unsigned char)); 	//erase buffer, after data was forwarded
				tx_cnt=0;
			}
		}
	}
}





//*************************RECEIVE

void rx_packet(void)
{	
	unsigned char test_char=0;
	unsigned int test_variable=0;
	static unsigned char rx_lastid=255;
	unsigned char i, rx_id, status;
	unsigned int rx_cnt;
	rx_cnt=rf12_rxdata(rxbuf, &status, &rx_id);		// komplettes Paket empfangen

		if ((rx_cnt) && !flag_1.RX_err)									// Daten empfangen
			{	


					for (i=0; i<rx_cnt; i++)			// Daten weiterleiten
					{
						uart_putc(rxbuf[i]);						
							
					}

			
			}
			

				
			
			//		message_array(rxbuf);
				
				
memset(rxbuf,0,MAX_BUF*sizeof(unsigned char));	//erase buffer	
	
}



//*******************************************TRANSMIT via radio

void tx_packet(unsigned char retrans)
{
//uart_putc(tx_cnt);

	rf12_stoprx();									// auf TX umschalten

//		rf12_txdata(txbuf, tx_cnt, tx_status, tx_id); // komplettes Paket senden
	if(fragmentation_size!=0)
		rf12_txdata(hallo_string, cnt_2, tx_status, tx_id);
	else
		rf12_txdata(txbuf, tx_cnt, tx_status, tx_id); // komplettes Paket senden

	rf12_rxmode();									// wieder auf RX umschalten

	//tx_cnt=0;
	
}






//********************************* CONFIG *********************************

#ifdef USE_SOFTCONFIG
void load_settings(void)
{

	if (eeprom_read_byte(&data_in_eeprom)!=0xAA)
	{

		rf_baud=RF_BAUDRATE;
		uart_baud=UART_BAUDRATE;
		channel=CHANNEL;
		threshold_1=THRESHOLD;
		environment_1=QUIET;
		bandwidth_1=_BANDWIDTH_;
		output_power_1=OUTPUT_POWER;
		save_settings();
	}


	channel=eeprom_read_byte(&channel_eeprom);
	output_power_1=eeprom_read_byte(&output_power_1_eeprom);
	rf_baud=eeprom_read_word(&rf_baud_eeprom);
	uart_baud=eeprom_read_word(&uart_baud_eeprom);
	threshold_1 = eeprom_read_byte(&threshold_1_eeprom); // lesen
	environment_1 = eeprom_read_byte(&environment_1_eeprom); // lesen
	bandwidth_1 = eeprom_read_byte(&bandwidth_1_eeprom); // lesen

	
}

void save_settings(void)
{

	eeprom_write_byte(&data_in_eeprom,0xAA);
	eeprom_write_byte(&channel_eeprom,channel);
	eeprom_write_word(&rf_baud_eeprom,rf_baud);
	eeprom_write_word(&uart_baud_eeprom,uart_baud);
	eeprom_write_byte(&threshold_1_eeprom, threshold_1); // write threshold
	eeprom_write_byte(&environment_1_eeprom, environment_1); // write environment
	eeprom_write_byte(&bandwidth_1_eeprom,bandwidth_1); // write bandwidth
	eeprom_write_byte(&output_power_1_eeprom, output_power_1); // write power

}



void configmode(void)
{	unsigned char c;
	uart_init(UART_BAUD_SELECT(CONFIG_BAUD, F_CPU));
flag_2.config_=1;

uart_putc('H');
		

uart_putc('X');
	for(;;)
	{	

		uart_puts_P("\r\n");
		
//		uart_puts_P("Config Menue\r\n\r\n");
	

		uart_puts_P("\r\nRS232 baudrate: ");
		show_number(uart_baud);
		uart_puts_P("\r\nRFM12 baudrate: ");
		show_number(rf_baud);
		uart_puts_P("\r\nchannel:        ");
		show_number(channel);
		uart_puts_P("\r\nDRSSI threshold: ");
		//uart_putc(threshold_1);
		show_number(threshold_1);
		uart_puts_P("\r\nEnvironment: ");
		//uart_putc(environment_1);
		show_number(environment_1);
		uart_puts_P("\r\nBandwidth: ");
		//uart_putc(bandwidth_1);
		show_number(bandwidth_1);
		uart_puts_P("\r\nOutput power: ");
		//uart_putc(output_power_1);
		show_number(output_power_1);

		


		uart_puts_P("\r\n");
	//	uart_puts_P("(1) set RS232 baudrate\r\n");
		uart_puts_P("(2) set RFM12 baudrate\r\n");
		uart_puts_P("(3) set RFM12 channel\r\n");
		uart_puts_P("(4) set DRSSI threshold\r\n");
		uart_puts_P("(5) set Environment\r\n");
		uart_puts_P("(6) set Bandwidth\r\n");
		uart_puts_P("(7) set Output power\r\n");
		uart_puts_P("(8) read Temperature\r\n");
		uart_puts_P("(9) Show available IDs\r\n");
		uart_puts_P("(i) send message to special ID\r\n");
	//	uart_puts_P("(e) send ECG as ascii\r\n");
		uart_puts_P("(f) receive ascii and convert\r\n");
		uart_puts_P("(g) stop send broadcast request for master\r\n");
		uart_puts_P("(j) send sinus\r\n");
		uart_puts_P("(a) frame segmentation\r\n");
	//	uart_puts_P("(k) fragmentation of frame\r\n");
		uart_puts_P("(c) send command\r\n");
		uart_puts_P("(d) Delete ID: \r\n");
		uart_puts_P("\r\n");
		uart_puts_P("(0) exit menu without saving\r\n");
		uart_puts_P("(s) exit menu and save settings\r\n");
		uart_puts_P("\r\n");

		for(;;)
		{	
			c=uart_getchar();

			if (c=='0')
			{
				timevalue = 0;
				flag_2.config_=0;
				timer_to_send_sin=0;
				return;
			}
			else if (c=='s')
			{	uart_puts_P("saved !\r\nLeaving config mode...\r\n");
				save_settings();
				_delay_ms(10);
				flag_2.config_=0;
				timevalue = 0;
				rf12_config(rf_baud, channel, output_power_1, environment_1,threshold_1,bandwidth_1);	// Baudrate, Kanal (0-3), Leistung (0=max, 7=min), Umgebungsbedingungen (QUIET, NORMAL, NOISY)
				timer_to_send_sin=0;//timer to send data frames
				return;
			}
		/*	else if (c=='1')
			{	uart_puts_P("Enter RS232 baudrate (300-150000)\r\n");
				uart_baud=read_number(300,150000,0);
				break;
			}*/
			else if (c=='2')
			{	uart_puts_P("Enter RFM12 baudrate (700-65000)\r\n");
				rf_baud=read_number(700,65000,0);	
				break;
			}
			else if (c=='3')
			{	uart_puts_P("Enter RFM12 channel (0-3)\r\n");
				channel=read_number(0,3,0);
				break;
			}
			else if (c=='4')
			{	uart_puts_P("Enter threshold (6-1) where (6 low sensitivity & 1 high sensitivity)\r\n");
				threshold_1=read_number(1,6,0);
				break;
			}
			else if (c=='5')
			{	uart_puts_P("Enter environment (1-3) where (1 quite environment & 3 noisy environment)\r\n");				
				environment_1=read_number(1,3,0);
				break;
			}
			else if (c=='6')
			{	uart_puts_P("Enter Bandwidth (1-6) where (1=400kHz, 2=340kHz, 3=270kHz, 4=200kHz, 5=134kHz, 6=67kHz) \r\n");				
				bandwidth_1=read_number(1,6,0);
				break;
			}
			else if (c=='7')
			{	uart_puts_P("Enter output power (0-7) where (0 highest power & 7 lowest power)\r\n");				
				output_power_1=read_number(0,7,0);
				break;
			}
			else
				break;
			
		}

			
		//	if (c=='0')
		//		return;
	}

}


void show_number(unsigned long val)
{	unsigned char i;
	char s[8]={32,32,32,32,32,32,32,0};
	i=6;
	do
	{	s[i--]=val%10+'0'; 
	}
	while  (val/=10);
	s[7]=0;
    uart_puts(s);
}

unsigned long read_number(unsigned long min, unsigned long max, unsigned long remote_change)
{	unsigned long number;
	unsigned char c,i;

	if(remote_change==0)		//remote settings
	{
		for (;;)
		{	number=0;
			for (i=0;i<6;i++)
  	  	{	c=uart_getchar();
    			if ((c==10)||(c==13)||(c==32))
    				break;
				if ((c>='0')&&(c<='9'))
				{	uart_putc(c);
					number=number*10+(c-'0');
				}
  	  	}
			if ((number>=min)&&(number<=max))
				break;
			uart_puts_P("Number out of range, try again !\r\n");
		}
   		return number;
	}
	else
		return remote_change;
}
#endif

void tx_via_radio(char *s)
{
	LED_TX = 1;
	strcpy((char*)txbuf,s);
	tx_cnt = strlen((char*)txbuf);
	tx_status=0;
	tx_packet(0);
	LED_TX = 0;
	tx_cnt=0;
}

ISR (TIMER0_COMP_vect)// 2ms interrupt
{

//	uart_puts("159786\r\n");
//	uart_puts("TIMER0\r\n");
	timer0_cnt++;

	if(timer0_cnt>=1500)//1500*0,002=3 sec, send every 3 seconds request for master ID to master
	{
		if(ID_cnt==0 && flag_1.i_am_master==0)
		{	
		//	flag_1.first_start_=TRUE;
		
	
		}
		timer0_cnt=0;
	}

	if(delaycnt)
	{
		delaycnt--;
	}
	
	timer_to_send_sin++;
}


ISR(TIMER2_OVF_vect)
{	
	if (sec<2) 
	{
		sec++;
		if(ready==1)
		{
			sleep = 1;
		}
	}
	else 
	{
	ready = 0;
	}
}
