#include <avr/io.h>
#include <avr/interrupt.h>


	// ADC intialisieren
void ADC_init()
{
	DDRA  |= (1<<PINA1);		// Eingangsspannung fr Regensensor
	PORTA |= (1<<PINA1);		// Eingangsspannung fr Regensensor

	ADCSRA =  (1<<ADEN) | (1<<ADPS2) | (1<<ADPS0);
	ADMUX &=~ (1<<REFS1);
	ADMUX |=  (1<<REFS0);
	ADMUX &=~ (1<<MUX4);
	ADMUX &=~ (1<<MUX3);
	ADMUX &=~ (1<<MUX2);
	ADMUX &=~ (1<<MUX1);
	ADMUX &=~ (1<<MUX0);
}	

	// ADC lesen
short ADC_read()
{
	short res;
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC));

	res = ADCL;
	res += (ADCH<<8);
	return res;
}	

